<?

/*
 * FlatNuke HotNews
 * Copyright (C) 2004-2006 Marco Segato
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the license, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, inc., 59 Temple Place - Suite 320, Boston, MA  02111-1207, USA
 */

/*
 * Blocco per FlatNuke (http://flatnuke.sourceforge.net) di Simone Vellei
 *
 * Autore    Marco Segato  <segatom@users.sourceforge.net>
 * Website   http://marcosegato.altervista.org
 * Versione  1.3
 * Data      20/01/2006
 */

/*
 * German translation by Bjrn at http://www.insites.tk
 */


// numero di news visualizzabili nel blocco, eventualmente modificabile facendolo coincidere con $newspp del config.php
//$numero_news = 10;
$numero_news = $newspp;

global $bgcolor3, $lang;

// definizione lingua
switch($lang) {
	case "de": $txt_header = "Zuletzt besuchte oder kommentierte News"; break;
	case "en": $txt_header = "Last visited and commented news"; break;
	case "es": $txt_header = "Noticias visitadas y comentadas del ltimo"; break;
	default: $txt_header = "Le ultime notizie visitate e commentate";
}

echo "<br>";
// apertura blocco
OpenTable();
// titolo blocco + intestazione tabella
echo "<div align='center'>
	<h3><img src='themes/$theme/images/hotnews.png' alt='HotNews'>&nbsp;&nbsp;$txt_header</h3>
	</div>
	<table align='center' width='98%' cellspacing='1'><tbody>
	<tr bgcolor='#$bgcolor3'>
		<td>&nbsp;&nbsp;<b>"._COMMENTI."</b></td>
		<td>&nbsp;&nbsp;<b>"._TITNOTIZIA."</b></td>
		<td align='center'><b>"._FUTENTE."</b></td>
		<td align='center'><img src='themes/$theme/images/letture.png' alt='Read'></td>
		<td align='center'><img src='themes/$theme/images/comment.png' alt='Comments'></td>
	</tr>";

// caricamento di tutte le news in un array
$news_dir = opendir('news');
while($file = readdir($news_dir)) {
	if(!($file=="." or $file=="..") and (!ereg("^\.",$file) and ($file!="CVS"))) {
		$f_time = filemtime("news/$file");
		$f_array[$file] = $f_time;
	}
}
closedir($news_dir);
// ordinamento delle news dalla pi recente alla pi vecchia
if(count($f_array)>0)
	arsort($f_array);
else return;
$tot_news = sizeof($f_array);

/**
 * Stampa il titolo della news e l'ultimo commento inserito
 *
 * @param string $news_file Notizia da visualizzare
 */
function print_hotnews($news_file) {
	$this_news = $news_file[0];
	$tmp = eregi_replace("^[0-9][0-9]_","",$this_news);
	$this_news = str_replace(".xml","",$tmp);
	$string = get_file("news/$this_news.xml");
	// non esistono commenti alla news
	if(!stristr($string, "<fn:comments>")) {
		$commento = "<a href='index.php?mod=comment&amp;id=$this_news'>&#043;</a>&nbsp;"._ADDCOMM."";
		$autore = "&#045;";
	}
	// estrazione dell'ultimo commento alla news e relativo autore
	else {
		$comments = get_xml_element("fn:comments",$string);
		$comment = get_xml_array("fn:comment",$comments);
		$post = get_xml_element("fn:post",$comment[count($comment)-1]);
		$by = get_xml_element("fn:by",$comment[count($comment)-1]);
		if(strlen($post) > 25)
			$commento = "<b>&middot;</b>&nbsp;".trim(strip_tags(substr($post,0,13)))."..";
		else $commento = "<b>&middot;</b>&nbsp;".trim(strip_tags($post));
		if(strlen($by) > 11)
			$autore = trim(substr($by,0,9))."..";
		else $autore = trim($by);
	}
	// estrazione titolo della news
	$title = ereg_replace(".*<fn:title>","",$string);
	$title = ereg_replace("</fn:title>.*","",$title);
	if(strlen($title) > 25)
		$title = trim(substr($title,0,13))."..";
	// estrazione numero di visite alla news
	$visite = ereg_replace(".*<fn:reads>","",$string);
	$visite = ereg_replace("</fn:reads>.*","",$visite);
	// pulizia stringhe
	$title = stripslashes($title);
	$fulltitle = $title;
	$commento = stripslashes($commento);

	// STAMPA TABELLA
	echo "<tr>";
	// commento
	echo "<td>$commento</td>";
	// titolo news
        echo "<td>&nbsp;<a href='index.php?mod=read&amp;id=$this_news'>$title</a></td>";
	// autore
	if($autore == _SCON or $autore == "&#045;")
		echo "<td align='center'>&nbsp;$autore</td>";
	else {
		// utente registrato -> profilo autore; utente non registrato -> avviso registrazione
		if(isset($_COOKIE['myforum']))
			echo "<td align='center'>&nbsp;<a href='forum/index.php?op=profile&amp;user=$autore' title='$fulltitle'>$autore</a></td>";
		else echo "<td align='center'>&nbsp;<a href='forum/index.php?op=members' title='$fulltitle'>$autore</a></td>";
	}
	// numero visite
	echo "<td align='center'>$visite</td>";
	// numero commenti
	echo "<td align='center'>".count_comment($this_news)."</td>";
	echo "</tr>";
}

switch($numero_news) {
	case($numero_news <= $tot_news):
		for ($i=0; $i<$numero_news; $i++) {
			$each_news = each($f_array);
			print_hotnews($each_news);
		}
	break;
	default:
		for ($i=0; $i<$tot_news; $i++) {
			$each_news = each($f_array);
			print_hotnews($each_news);
		}
}

// chiusura tabella
echo "</tbody></table>";
// chiusura blocco
CloseTable();

?>